#define HAVE_LONG_LONG 1
/* * This file was generated by SLIRP, the (Sl)ang (I)nte(r)face (P)ackage,
 * a S-Lang module code generator for C, C++, and FORTRAN.
 *
 * Copyright (C) 2003-2006 Massachusetts Institute of Technology 
 * Copyright (C) 2002 Michael S. Noble <mnoble@space.mit.edu>
 *
 * SLIRP is free software, and may be used under the conditions stipulated
 * in the COPYRIGHT agreement bundled within the SLIRP distribution.
 */
#include <stdlib.h>		/* SLIRP common {{{ */
#include <unistd.h>
#include <string.h>
#include <stdarg.h>
#include <slang.h>

#define V				SLANG_VOID_TYPE
#define SLEU				SL_USAGE_ERROR
#define SLEI				SL_INTRINSIC_ERROR
#define SAFE_DEREF_OPAQUE(po)		(po == NULL ? NULL : po->instance)
#define SAFE_DEREF_ARRAY(pa)		(pa == NULL ? NULL : pa->data)
#define SLang_pop_array(x)		SLang_pop_array(x, 1)
#define SLang_pop_string(x)             SLang_pop_slstring(x)
#define SLang_push_size_t		SLang_push_int
#define SLang_push_ptrdiff_t		SLang_push_int

#define pop_defaultable(argno, kind, type, obj, value) \
   (SLang_Num_Function_Args >= argno ? SLang_pop_##kind ( (type*)&obj) : ((obj = value) || ( (void*)&obj > (void*)0) ) )

#ifdef __cplusplus
#define LINKAGE "C"
#else
#define LINKAGE
#endif

static void Slirp_usage(int i, int j, int flags);

static int slang_abi_mismatch(void)
{
   long module_abi = SLANG_VERSION / 10000;
   long app_abi    = SLang_Version / 10000;

   if (module_abi != app_abi) {
	SLang_verror(SL_APPLICATION_ERROR, (char*)
		"S-Lang library abi mismatch\nmodule: %s, application: %s",
		SLANG_VERSION_STRING, SLang_Version_String);
	return 1;
   }
			        
   return 0;
} /* }}} */

#if SLANG_VERSION < 20000 /* {{{ */
#define SLclass_get_class_id(x)	(x)->cl_data_type
#define SLang_get_error()	SLang_Error
#define SLang_set_error(x)	(SLang_Error = (x))
#define SLang_pop_double(x)	SLang_pop_double(x, NULL, NULL)
#define SLang_pop_uint		SLang_pop_uinteger
#define SLang_pop_int		SLang_pop_integer
#define SLang_push_uint		SLang_push_uinteger
#define SLang_push_int		SLang_push_integer
#define SLutf8_enable(x)	x
#define SLang_pop_struct	_SLang_pop_struct
#define SLang_free_struct	_SLstruct_delete_struct
#define SLstack_depth		_SLstack_depth
#define SLuindex_Type		unsigned int
#define SLindex_Type		int
extern LINKAGE int _SLstack_depth(void);
#endif /* }}} */

#include <ao/ao.h>
#define BEGIN_DECLS
#define END_DECLS
#define SLIRP_EXTERN
BEGIN_DECLS				/* Opaque handling code {{{ */

#define SLIRP_ABI_VERSION			10500

typedef void            (*FINALIZER)            (void*);
typedef void            (*INITIALIZER)          (void*);

typedef struct _Slirp_Type {
   SLang_Class_Type	*slclass;	/* SLang type class for this type */
   struct _Slirp_Type	*parent;	/* NULL if type has no ancestors  */
   FINALIZER		finalizer;
   INITIALIZER		initializer;
} Slirp_Type;

typedef struct _Slirp_Opaque {
   Slirp_Type *type;
   SLang_MMT_Type *mmt;
   void* instance;
   unsigned int owns_ref;
} Slirp_Opaque;
#define SLang_free_opaque(o)	if (o != NULL) SLang_free_mmt(o->mmt)

static int opaque_typecast (SLtype from_type, VOID_STAR from_p,
			unsigned int num, SLtype to_type, VOID_STAR to_p)
{
   unsigned int i;
   SLang_MMT_Type **from = (SLang_MMT_Type**)from_p;
   SLang_MMT_Type **to   = (SLang_MMT_Type**)to_p;

   (void) from_type; (void) to_type; 

   for (i=0; i < num; i++) {
	to[i] = from[i];	/* FIXME: typeof() still reports prev type */
	if (from[i] != NULL)
	   SLang_inc_mmt(from[i]);
   }

   return 1;
}

static int opaque_search(const void* key, const void *elem)
{
   return *(SLtype*)key - SLclass_get_class_id((*(Slirp_Type**)elem)->slclass);
}

static void destroy_opaque(SLtype type, VOID_STAR w)
{
   Slirp_Opaque *ot = (Slirp_Opaque*)w;

   (void) type;

   if (ot->type->finalizer != NULL)
      (*ot->type->finalizer) (ot->instance);

   SLfree( (char*)w );
}
END_DECLS

SLIRP_EXTERN SLtype void_ptr_Type;	/* These opaque pointer types must */
SLIRP_EXTERN SLtype string_ptr_Type;	/* be kept in sync with opaques.c  */
SLIRP_EXTERN SLtype uchar_ptr_Type;
SLIRP_EXTERN SLtype short_ptr_Type;
SLIRP_EXTERN SLtype ushort_ptr_Type;
SLIRP_EXTERN SLtype int_ptr_Type;
SLIRP_EXTERN SLtype uint_ptr_Type;
SLIRP_EXTERN SLtype long_ptr_Type;
SLIRP_EXTERN SLtype ulong_ptr_Type;
SLIRP_EXTERN SLtype float_ptr_Type;
SLIRP_EXTERN SLtype double_ptr_Type;
SLIRP_EXTERN SLtype opaque_ptr_Type;
SLIRP_EXTERN SLtype file_ptr_Type;

typedef struct _Reserved_Opaque_Type {
   char	  *name;
   SLtype *type;		/* SLtype of opaque pointer defined by this */
   SLtype masked_type;		/* SLtype of datum to which this points */
} Reserved_Opaque_Type;

SLIRP_EXTERN Slirp_Type	**Slirp_Opaque_Types;
SLIRP_EXTERN SLtype 	Slirp_Num_Opaque_Types;
SLIRP_EXTERN SLtype	First_Opaque_Type;
SLIRP_EXTERN SLtype	Last_Reserved_Opaque_Type;

static Reserved_Opaque_Type Reserved_Opaque_Types[] = {

   { (char*)"void_ptr",		&void_ptr_Type,		SLANG_ANY_TYPE,    },
   { (char*)"int_ptr",		&int_ptr_Type,		SLANG_INT_TYPE,    },
   { (char*)"double_ptr",	&double_ptr_Type,	SLANG_DOUBLE_TYPE, },
   { (char*)"opaque_ptr",	&opaque_ptr_Type,	SLANG_ANY_TYPE,	   },
   { (char*)"file_ptr",		&file_ptr_Type,		SLANG_FILE_PTR_TYPE,},
   { (char*)"float_ptr",	&float_ptr_Type,	SLANG_FLOAT_TYPE,  },
   { (char*)"long_ptr",		&long_ptr_Type,		SLANG_LONG_TYPE,   },
   { (char*)"string_ptr",	&string_ptr_Type,	SLANG_STRING_TYPE, },
   { (char*)"uint_ptr",		&uint_ptr_Type,		SLANG_UINT_TYPE,   },
   { (char*)"short_ptr",	&short_ptr_Type,	SLANG_SHORT_TYPE,  },
   { (char*)"ulong_ptr",	&ulong_ptr_Type,	SLANG_ULONG_TYPE,  },
   { (char*)"ushort_ptr",	&ushort_ptr_Type,	SLANG_USHORT_TYPE, },
   { (char*)"uchar_ptr",	&uchar_ptr_Type,	SLANG_UCHAR_TYPE,  },
   { NULL, NULL, 0, }
};

#define NUM_RESERVED_OPAQUES \
	sizeof(Reserved_Opaque_Types) / sizeof(Reserved_Opaque_Type) - 1

static Slirp_Type* sltype_to_slirp_type(SLtype sltype)
{
   Slirp_Type **ot = (Slirp_Type**) bsearch( (const void*) &sltype,
	 		(const void*) Slirp_Opaque_Types,
			(size_t) Slirp_Num_Opaque_Types,
			sizeof(Slirp_Type*), opaque_search);

   if (ot != NULL) return *ot;
   return NULL;
}

static SLang_MMT_Type*
create_opaque_mmt(SLtype type, void *instance, unsigned int owns_ref)
{
   SLang_MMT_Type *mmt = NULL;
   Slirp_Opaque *ot = (Slirp_Opaque*) SLmalloc(sizeof(Slirp_Opaque));

   if (ot != NULL) {

	ot->instance = instance;
	ot->owns_ref = owns_ref;
	ot->mmt      = NULL;

	if ( (ot->type = sltype_to_slirp_type(type)) != NULL) {

	   if (ot->type->initializer != NULL)
		(*ot->type->initializer) (ot->instance);

	   mmt = SLang_create_mmt (type, (VOID_STAR) ot);
	}

	if (mmt == NULL)
	   SLfree((char*)ot);
   }

   return mmt;
}

static int SLang_push_opaque(SLtype type, void *instance, unsigned int owns_ref)
{
   SLang_MMT_Type *mmt;

   if (instance == NULL)
      return SLang_push_null();

   mmt = create_opaque_mmt(type, instance, owns_ref);
   if (NULL == mmt)
      return -1;

   return SLang_push_mmt(mmt);
}

static int SLang_pop_opaque(SLtype type, void **instance, Slirp_Opaque **o)
{
   Slirp_Opaque *ot;
   SLang_MMT_Type *mmt = NULL;

   if (type == file_ptr_Type && SLang_peek_at_stack() == SLANG_FILE_PTR_TYPE) {
	FILE *fp;
	if (SLang_pop_fileptr(&mmt, &fp) == 0) {
	   ot = (Slirp_Opaque*) SLmalloc(sizeof(Slirp_Opaque));
	   if (ot == NULL) { SLang_free_mmt(mmt); return -1; }
	   ot->mmt = mmt; *instance = (void*)fp; *o = ot; return 0;
	}
   }
   else if (	(mmt = SLang_pop_mmt(type)) != NULL &&
		(ot = (Slirp_Opaque*) SLang_object_from_mmt (mmt)) != NULL &&
		ot->instance != NULL) {

	ot->mmt = mmt;
	if (instance != NULL)
	   *instance = ot->instance;
	*o = ot;
	return 0;
   }

   if (instance != NULL) *instance = NULL;
   SLang_free_mmt (mmt);
   return -1;
}

static unsigned int
allocate_opaque(char *name, FINALIZER fzer, INITIALIZER izer, SLtype parent_id)
{
   /* Returning from here with anything but a positive id is fatal */
   SLtype new_type, ancestor_type;
   Slirp_Type *type , *parent = NULL;
   SLang_Class_Type *new_class = SLclass_allocate_class (name);

   if (new_class == NULL) return SLANG_UNDEFINED_TYPE;

   (void) SLclass_set_destroy_function (new_class, destroy_opaque);
   if (-1 == SLclass_register_class (new_class, SLANG_VOID_TYPE,
				     sizeof(Slirp_Opaque),
				     SLANG_CLASS_TYPE_MMT))
	return SLANG_UNDEFINED_TYPE;

   new_type = SLclass_get_class_id(new_class);
   if (parent_id) {

	type = parent = sltype_to_slirp_type(parent_id);

	while (type) {

	   ancestor_type = SLclass_get_class_id(type->slclass);

	   /* Support downcasting ancestor types to this type */
	   if (-1 == SLclass_add_typecast (ancestor_type, new_type,
		    					opaque_typecast, 1))
		return SLANG_UNDEFINED_TYPE;

	   /* Support upcasting this type to each ancestor type */
	   if (-1 == SLclass_add_typecast (new_type, ancestor_type,
							opaque_typecast, 1))
		return SLANG_UNDEFINED_TYPE;

	   type = type->parent;
	}
   }

   if ( (type = (Slirp_Type*) SLmalloc(sizeof(Slirp_Type))) == NULL)
	return SLANG_UNDEFINED_TYPE;

   type->slclass = new_class;
   type->parent = parent;
   type->finalizer = fzer;
   type->initializer = izer;
   Slirp_Opaque_Types[ Slirp_Num_Opaque_Types++ ] = type;

   return new_type;
}

static int allocate_reserved_opaque_types(void)
{
   Reserved_Opaque_Type *pt;
   long abi_version = -1;

   if ( SLang_is_defined((char*)"_slirp_initialized")) {

	if ( SLang_is_defined((char*)"_slirp_abi_version") == 0  ||
		SLang_load_string((char*)"_slirp_abi_version;") == -1 ||
		SLang_pop_long(&abi_version) == -1 ||
		abi_version != SLIRP_ABI_VERSION)
	{
	   SLang_verror(SLEU,
		(char*) "SLIRP abi mismatch: want version %ld, have %ld\n",
		(long)SLIRP_ABI_VERSION, abi_version);
	   return -1;
	}

	return 0;
   }

   (void)SLang_load_string((char*)"public variable _slirp_initialized=1;");
   (void)SLang_push_int(SLIRP_ABI_VERSION);
   (void)SLang_load_string((char*)"public variable _slirp_abi_version=();");

   Slirp_Num_Opaque_Types = 0;

   if ( NULL == (Slirp_Opaque_Types = (Slirp_Type**) SLmalloc
			( sizeof(Slirp_Type*) * (NUM_RESERVED_OPAQUES + 1))))
      return -1;

   Slirp_Opaque_Types[0] = NULL;

   pt = Reserved_Opaque_Types;
   while (pt->name != NULL) {
	if ((*pt->type = allocate_opaque(pt->name, NULL, NULL, 0)) ==
	      						SLANG_UNDEFINED_TYPE)
		return -1;
	   pt++;
	}

   /* Loop again, to enable casts to/from generic pointer type */
   pt = Reserved_Opaque_Types + 1;
   while (pt->name != NULL) {

	if (-1 == SLclass_add_typecast (*pt->type, void_ptr_Type,
							opaque_typecast, 1))
	   return SLANG_UNDEFINED_TYPE;

	if (-1 == SLclass_add_typecast (void_ptr_Type, *pt->type,
							opaque_typecast, 1))
	   return SLANG_UNDEFINED_TYPE;

	pt++;
   }

   First_Opaque_Type = *Reserved_Opaque_Types[0].type;
   Last_Reserved_Opaque_Type = First_Opaque_Type + NUM_RESERVED_OPAQUES - 1;

   return 0;
} /* }}} */

static int pop_nullable(SLtype type, void **obj, void **meta)
{
   if (SLANG_NULL_TYPE == SLang_peek_at_stack ()) { 
	*obj = NULL;
	if (type && meta != NULL)
	   *meta = NULL;
	return SLang_pop_null ();
   }

   switch(type) {

	case 0:
	   return SLang_pop_cstruct(*obj, (SLang_CStruct_Field_Type *)meta);

	case SLANG_ANY_TYPE:
	   return SLang_pop_anytype((SLang_Any_Type**)obj);

	case SLANG_REF_TYPE:
	   return SLang_pop_ref((SLang_Ref_Type**)obj);

	case SLANG_STRING_TYPE:
	   return SLang_pop_slstring ((char**)obj);

	default:
	   /* This will fail, as intended, for non-opaque types */
	   return SLang_pop_opaque(type, meta, (Slirp_Opaque**)obj);
   }
}
#define pop_string_or_null(s)  pop_nullable(SLANG_STRING_TYPE,(void**)s,NULL)
#define pop_ref_or_null(r)  pop_nullable(SLANG_REF_TYPE,(void**)&r->ref,r->data)
#define pop_anytype_or_null(a) pop_nullable(SLANG_ANY_TYPE,(void**)a,NULL)

SLtype ao_device_ptr_Type = 0;
SLtype ao_sample_format_ptr_Type = 0;
SLtype ao_option_ptr_Type = 0;
SLtype ao_info_ptr_Type = 0;

static int allocate_ao_opaque_types(void) /* {{{ */
{
   if (ao_device_ptr_Type) return 0;

   Slirp_Opaque_Types = (Slirp_Type**) SLrealloc((char*)Slirp_Opaque_Types,
		(1 + Slirp_Num_Opaque_Types + 4) * sizeof(Slirp_Type*));

   if (Slirp_Opaque_Types == NULL) return -1;

   ao_device_ptr_Type = allocate_opaque((char*)"ao_device_ptr",
		(FINALIZER) NULL, 
		(INITIALIZER) NULL,
		(SLtype) void_ptr_Type);
   if (ao_device_ptr_Type == SLANG_UNDEFINED_TYPE) return -1;

   ao_sample_format_ptr_Type = allocate_opaque((char*)"ao_sample_format_ptr",
		(FINALIZER) NULL, 
		(INITIALIZER) NULL,
		(SLtype) void_ptr_Type);
   if (ao_sample_format_ptr_Type == SLANG_UNDEFINED_TYPE) return -1;

   ao_option_ptr_Type = allocate_opaque((char*)"ao_option_ptr",
		(FINALIZER) NULL, 
		(INITIALIZER) NULL,
		(SLtype) void_ptr_Type);
   if (ao_option_ptr_Type == SLANG_UNDEFINED_TYPE) return -1;

   ao_info_ptr_Type = allocate_opaque((char*)"ao_info_ptr",
		(FINALIZER) NULL, 
		(INITIALIZER) NULL,
		(SLtype) void_ptr_Type);
   if (ao_info_ptr_Type == SLANG_UNDEFINED_TYPE) return -1;

   return 0;
} /* }}} */

typedef struct _Slirp_Ref 
{                        /* Ref handling code {{{ */
   #define REF_FLAG_FREE_DATA                      0x01
   #define REF_FLAG_IS_OPAQUE                      0x02
   #define REF_FLAG_COLUMN_MAJOR                   0x04
   #define REF_FLAG_ARRAY_EXPECTED                 0x08
      unsigned int         flags;          /* Slirp_Ref encapsulates S-Lang    */
      SLtype               sltype;         /* array, ref, and MMT types, the   */
      size_t               sizeof_type;    /* latter two of which are seen as  */
      void                 **data;         /* pointing to a single object      */
      unsigned int         vstride;        /* how to find "next" vectored elem */
      SLang_Array_Type     *array;
      SLang_Ref_Type       *ref;
      SLang_MMT_Type       *mmt;           /* mmt supports passing around C    */
}
Slirp_Ref;                            /* ptr arrays of indeterminate size */

static unsigned int ref_get_size(Slirp_Ref *r, int which_dimension) /* {{{ */
{
   if (0) (void) &ref_get_size;	/* avoid compiler warnings if unused */

   if (r->array) {
	if (which_dimension == 0)
	   return (unsigned int)r->array->num_elements;
	else if (which_dimension < 0)
	   return r->array->num_dims;
	else {
	   which_dimension--;
	   if ((unsigned int)which_dimension < r->array->num_dims)
		return (unsigned int)r->array->dims[which_dimension];
	   else
		return 0;
	}
   }

   return 1;
} /* }}} */

extern LINKAGE int _SLang_get_class_type (SLtype t);	/* quasi-public  */

#define POP_FLAG_NULLABLE	0x1
#define POP_FLAG_VECTORIZE	0x2
/* }}} */

SLang_CStruct_Field_Type ao_sample_format_Layout [] =
{
   MAKE_CSTRUCT_FIELD (ao_sample_format, bits, "bits", SLANG_INT_TYPE, 0),
   MAKE_CSTRUCT_FIELD (ao_sample_format, rate, "rate", SLANG_INT_TYPE, 0),
   MAKE_CSTRUCT_FIELD (ao_sample_format, channels, "channels", SLANG_INT_TYPE, 0),
   MAKE_CSTRUCT_FIELD (ao_sample_format, byte_format, "byte_format", SLANG_INT_TYPE, 0),
   SLANG_END_CSTRUCT_TABLE
};

SLang_CStruct_Field_Type ao_info_Layout [] =
{
   MAKE_CSTRUCT_FIELD (ao_info, type, "type", SLANG_INT_TYPE, 1),
   MAKE_CSTRUCT_FIELD (ao_info, name, "name", SLANG_STRING_TYPE, 1),
   MAKE_CSTRUCT_FIELD (ao_info, short_name, "short_name", SLANG_STRING_TYPE, 1),
   MAKE_CSTRUCT_FIELD (ao_info, comment, "comment", SLANG_STRING_TYPE, 1),
   MAKE_CSTRUCT_FIELD (ao_info, preferred_byte_format, "preferred_byte_format", SLANG_INT_TYPE, 1),
   MAKE_CSTRUCT_FIELD (ao_info, priority, "priority", SLANG_INT_TYPE, 1),
   MAKE_CSTRUCT_FIELD (ao_info, options, "options", SLANG_ARRAY_TYPE, 1),
   SLANG_END_CSTRUCT_TABLE
};

/* Wrapper functions */ /* {{{ */
static void sl_ao_driver_info (void)
{
   ao_info *info;
   int arg1;
   SLang_Array_Type *a;
      
   if (SLang_Num_Function_Args != 1 ||
	SLang_pop_int((int*)&arg1) == -1 )
	{Slirp_usage(0,0,0); return;}

   info = ao_driver_info (arg1);

   a = SLang_create_array (SLANG_STRING_TYPE, 0, info->options, &info->option_count, 1);
   info->options = (char **) a;
   SLang_push_cstruct ((VOID_STAR)info, ao_info_Layout);
   SLang_free_array (a);
}

static void sl_ao_file_extension (void)
{
   char* retval = "";
   int arg1;

   if (SLang_Num_Function_Args != 1 ||
	SLang_pop_int((int*)&arg1) == -1 )
	{Slirp_usage(1,1,0); return;}

   /* retval = ao_file_extension( arg1); */
   SLang_push_string(retval);
}

static void sl_ao_driver_id (void)
{
   int retval;
   char* arg1;

   if (SLang_Num_Function_Args != 1 ||
	SLang_pop_string((char**)&arg1) == -1 )
	{Slirp_usage(2,2,0); return;}

   retval = ao_driver_id(arg1);
   SLang_push_int(retval);
   SLang_free_slstring(arg1);
}

static void sl_ao_open_live (void)
{
   ao_device* retval;
   int arg1;
   ao_sample_format arg2;
   ao_option* arg3;
   Slirp_Opaque* arg3_o = NULL;
   
   if (SLang_Num_Function_Args != 3 ||
       pop_nullable(ao_option_ptr_Type, (void**)&arg3_o, (void**)&arg3) == -1 ||
       SLang_pop_cstruct ((VOID_STAR)&arg2, ao_sample_format_Layout) == -1 ||
       SLang_pop_int((int*)&arg1) == -1 )
     {Slirp_usage(3,3,0); return;}

   retval = ao_open_live (arg1, &arg2, arg3);   
   SLang_push_opaque(ao_device_ptr_Type, (void*)retval, 0);
   
   ao_free_options (arg3);
   SLang_free_opaque(arg3_o);
}

static void sl_ao_append_option (void)
{
   ao_option* arg1 = NULL;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   char* arg3;
   
   if (SLang_Num_Function_Args != 3 ||
       SLang_pop_string((char**)&arg3) == -1 ||
       SLang_pop_string((char**)&arg2) == -1 ||
       pop_nullable(ao_option_ptr_Type, (void**)&arg1_o, (void**)&arg1) == -1)
     {Slirp_usage(4,4,0); return;}
   
   ao_append_option (&arg1, arg2, arg3);

   SLang_push_opaque(ao_option_ptr_Type, (void*)arg1, 0);
   SLang_free_opaque(arg1_o);
   SLang_free_slstring(arg2);
   SLang_free_slstring(arg3);
}

static void sl_ao_is_big_endian (void)
{
   int retval;
   if (SLang_Num_Function_Args != 0)
	{Slirp_usage(5,5,0); return;}

   retval = ao_is_big_endian();
   SLang_push_int(retval);
}

static void sl_ao_open_file (void)
{
   ao_device* retval;
   int arg1;
   char* arg2;
   int arg3;
   ao_sample_format arg4;
   ao_option* arg5;
   Slirp_Opaque* arg5_o = NULL;
   
   
   if (SLang_Num_Function_Args != 5 ||
       pop_nullable(ao_option_ptr_Type, (void**)&arg5_o, (void**)&arg5) == -1 ||
       SLang_pop_cstruct ((VOID_STAR)&arg4, ao_sample_format_Layout) == -1 ||
       SLang_pop_int((int*)&arg3) == -1 ||
       SLang_pop_string((char**)&arg2) == -1 ||
       SLang_pop_int((int*)&arg1) == -1 )
	{Slirp_usage(6,6,0); return;}

   retval = ao_open_file( arg1, arg2,  arg3, &arg4, arg5);
   SLang_push_opaque(ao_device_ptr_Type, (void*)retval, 0);
   
   ao_free_options (arg5);
   SLang_free_slstring(arg2);
}

static void sl_ao_shutdown (void)
{
   if (SLang_Num_Function_Args != 0)
	{Slirp_usage(7,7,0); return;}

   ao_shutdown();
}

static void sl_ao_close (void)
{
   ao_device* arg1;
   Slirp_Opaque* arg1_o = NULL;

   if (SLang_Num_Function_Args != 1 ||
	SLang_pop_opaque(ao_device_ptr_Type, (void**)&arg1, &arg1_o) == -1 )
	{Slirp_usage(8,8,0); return;}

   ao_close(arg1);
   SLang_free_opaque(arg1_o);
}

static void sl_ao_initialize (void)
{
   if (SLang_Num_Function_Args != 0)
	{Slirp_usage(9,9,0); return;}

   ao_initialize();
}

static void sl_ao_default_driver_id (void)
{
   int retval;
   if (SLang_Num_Function_Args != 0)
	{Slirp_usage(10,10,0); return;}

   retval = ao_default_driver_id();
   SLang_push_int(retval);
}

static void sl_ao_play (void)
{
   ao_device* arg1;
   Slirp_Opaque* arg1_o = NULL;
   SLang_Array_Type *a;

   if (SLang_Num_Function_Args != 2 ||
       SLang_pop_array_of_type (&a, SLANG_CHAR_TYPE) == -1 ||
       SLang_pop_opaque(ao_device_ptr_Type, (void**)&arg1, &arg1_o) == -1 )
	{Slirp_usage(11,11,0); return;}

   SLang_push_int (ao_play(arg1, a->data, a->dims [0]));
   SLang_free_opaque(arg1_o);
}

static void sl_ao_driver_info_list (void)
{
   int driver_count;
   
   if (SLang_Num_Function_Args != 0)
     {Slirp_usage(12,12,0); return;}   
   
   (void) ao_driver_info_list (&driver_count);
   
   SLang_push_int (driver_count);
}

static SLang_Intrin_Fun_Type ao_Funcs [] =
{
   MAKE_INTRINSIC_0((char*)"ao_driver_info",sl_ao_driver_info,V),
   MAKE_INTRINSIC_0((char*)"ao_file_extension",sl_ao_file_extension,V),
   MAKE_INTRINSIC_0((char*)"ao_driver_id",sl_ao_driver_id,V),
   MAKE_INTRINSIC_0((char*)"_ao_open_live",sl_ao_open_live,V),
   MAKE_INTRINSIC_0((char*)"ao_append_option",sl_ao_append_option,V),
   MAKE_INTRINSIC_0((char*)"ao_is_big_endian",sl_ao_is_big_endian,V),
   MAKE_INTRINSIC_0((char*)"_ao_open_file",sl_ao_open_file,V),
   MAKE_INTRINSIC_0((char*)"ao_shutdown",sl_ao_shutdown,V),
   MAKE_INTRINSIC_0((char*)"ao_close",sl_ao_close,V),
   MAKE_INTRINSIC_0((char*)"ao_initialize",sl_ao_initialize,V),
   MAKE_INTRINSIC_0((char*)"ao_default_driver_id",sl_ao_default_driver_id,V),
   MAKE_INTRINSIC_0((char*)"ao_play",sl_ao_play,V),
   MAKE_INTRINSIC_0((char*)"_ao_driver_info_list",sl_ao_driver_info_list,V),
   SLANG_END_INTRIN_FUN_TABLE
};   /* }}} */

static const char* usage_strings[] = { /* {{{ */
   "ao_info_ptr = ao_driver_info(int)",
   "string = _ao_file_extension(int)",
   "int = ao_driver_id(string)",
   "ao_device_ptr = _ao_open_live(int,ao_sample_format_ptr,ao_option_ptr)",
   "ao_append_option(string,string)",
   "int = ao_is_big_endian()",
   "ao_device_ptr = ao_open_file(int,string,int,ao_sample_format_ptr,ao_option_ptr)",
   "ao_shutdown()",
   "ao_close(ao_device_ptr)",
   "ao_initialize()",
   "int = ao_default_driver_id()",
   "ao_play(ao_device_ptr,char [])",
   "ao_option_ptr = ao_new_options ()",
   "[ao_option_ptr] = sl_ao_driver_info_list ()",
NULL
}; /* }}} */

static void Slirp_usage(int i, int last, int flags) /* {{{ */
{
   char *indent;
   int npop = SLstack_depth();
   if (npop > SLang_Num_Function_Args) npop = SLang_Num_Function_Args;
   SLdo_pop_n(npop);
   if (last == i)
	indent = (char*)"Usage:  ";
   else {
	indent = (char*)"\t";
	SLang_verror(SLEU, (char*)"Usage: one of");
   }
   do
	SLang_verror(SLEU, (char*)"%s%s", indent, usage_strings[i++]);
   while (i < last);
   if (flags & 0x2)
	SLang_verror(SLEU,
		(char*)"\tThis function has been vectorized and parallelized.");
   else if (flags & 0x1)
	SLang_verror(SLEU, (char*)"\tThis function has been vectorized.");
} /* }}} */

static SLang_IConstant_Type ao_IConsts [] =	/* {{{ */
{
   MAKE_ICONSTANT((char*)"AO_FMT_BIG",2),
   MAKE_ICONSTANT((char*)"AO_FMT_NATIVE",4),
   MAKE_ICONSTANT((char*)"AO_FMT_LITTLE",1),
   MAKE_ICONSTANT((char*)"AO_TYPE_LIVE",1),
   MAKE_ICONSTANT((char*)"AO_TYPE_FILE",2),
   SLANG_END_ICONST_TABLE
};	/* }}} */

#define   SLIRP_VERSION	10903
SLANG_MODULE(ao);
int init_ao_module_ns(char *ns_name)	/* {{{ */
{
   SLang_NameSpace_Type *ns = NULL;

   if (slang_abi_mismatch()) return -1;
   if (ns_name != NULL) {
	ns = SLns_create_namespace (ns_name);
	if (ns == NULL) return -1;
   }


   if (allocate_reserved_opaque_types() == -1) return -1;
   if (allocate_ao_opaque_types() == -1) return -1;

   if ( -1 == SLns_add_iconstant_table(ns,ao_IConsts,NULL) ||
	-1 == SLns_add_intrin_fun_table (ns,ao_Funcs,(char*)"__ao__"))
		return -1;

   return 0;
} /* }}} */
