import ("ao");

typedef struct
{
   bits, rate, channels, byte_format
} ao_sample_format;

define ao_open_live (driver_id, format)
{
   variable name, opt = NULL, options;
   
   options = __qualifiers;
   if (options != NULL)
     {	
	foreach name (get_struct_field_names (options))
	  opt = ao_append_option (opt, name, get_struct_field (options, name));
     }         

   _ao_open_live (driver_id, format, opt);
}

define ao_open_file (driver_id, filename, overwrite, format)
{
   variable name, opt = NULL, options;
   
   options = __qualifiers;
   if (options != NULL)
     {	
	foreach name (get_struct_field_names (options))
	  opt = ao_append_option (opt, name, get_struct_field (options, name));
     }         
   
   _ao_open_file (driver_id, filename, overwrite, format, opt);
}

define ao_driver_info_list ()
{
   variable i, driver_count = _ao_driver_info_list ();
   variable drivers = Struct_Type [driver_count];
   
   _for i (0, driver_count - 1, 1) 
     drivers [i] = ao_driver_info (i);
   
   return drivers;
}

define ao_fill_buffer ()
{
   variable samples = __pop_list (_NARGS);
   variable format = list_pop (samples);
   variable buffer = Char_Type [format.channels * format.bits / 8 * format.rate];
   variable i, j;
   
   if (format.bits == 8)
     {	
	_for i (0, length (samples) - 1, 1)
	  {
	     samples [i] = samples [i] / max (samples [i]);
	     samples [i] = typecast (127 * samples [i], Char_Type);
	  }
	while (length (samples) < format.channels)
	  list_append (samples, samples [-1]);
	_for i (0, format.rate - 1, 1)
	  {
	     _for j (0, format.channels - 1, 1)
	       buffer [format.channels * i + j] = samples [j][i];
	  }
     }
   else if (format.bits == 16)
     {	
	_for i (0, length (samples) - 1, 1)
	  {
	     samples [i] = samples [i] / max (samples [i]);
	     samples [i] = typecast (32767 * samples [i], Short_Type);
	  }
	while (length (samples) < format.channels)
	  list_append (samples, samples [-1]);
	_for i (0, format.rate - 1, 1)
	  {
	     _for j (0, format.channels - 1, 1)
	       {		  
		  buffer [2 * (format.channels * i + j)] = samples [j][i] & 0xFF;
		  buffer [2 * (format.channels * i + j) + 1] = (samples [j][i] shr 8) & 0xFF;
	       }	     
	  }
     }
   return buffer;
}

provide ("ao");
