#!/usr/bin/env slsh

require ("ao");

variable driver, info;

ao_initialize ();

if (length (__argv) == 2)
  driver = ao_driver_id (__argv [1]);
else
  driver = ao_default_driver_id ();

if (driver == -1)
{
   message ("No driver by that name exists");
   exit (0);
}

info = ao_driver_info (driver);

foreach $0 (get_struct_field_names (info))
{   
   $1 = get_struct_field (info, $0);
   if ($0 == "options")
     vmessage ("%s = %s", $0, strjoin ($1, ", "));
   else
     vmessage ("%s = %s", $0, string ($1));
}

ao_shutdown ();
