#!/usr/bin/env slsh

% This example plays a ".wav" audio file

require ("ao");

variable bits, buf, channels, device, driver, format, fp, rate, size;

if (length (__argv) != 2)
{   
   message ("Usage : play.sl file.wav");
   exit ();
}

fp = fopen (__argv [1], "r");

() = fread_bytes (&buf, 44, fp);
(,,,,,, channels, rate,,, bits,, size) =  unpack ("s4Ks4s4KJJKKJJs4K", buf);

ao_initialize ();

driver = ao_default_driver_id ();

format = @ao_sample_format;
format.bits = bits;
format.channels = channels;
format.rate = rate;
format.byte_format = AO_FMT_LITTLE;

device = ao_open_live (driver, format);

$0 = size / (channels * rate * bits / 8);
vmessage ("Playing at %d Hz / %d bits / %d channels [%d:%02d]",
	  rate, bits, channels, $0 / 60, $0 mod 60);

while (fread (&buf, Char_Type, 10000, fp) != -1)
  () = ao_play (device, buf);

() = fclose (fp);

ao_close (device);

ao_shutdown ();
