#!/usr/bin/env slsh

require ("ao");

variable buffer, driver, device, format, freq, options, sample, samples, w;

ao_initialize ();

driver = ao_default_driver_id ();
% driver = ao_driver_id ("wav");
% driver = ao_driver_id ("null");

format = @ao_sample_format;
format.bits = 16;
format.channels = 2;
format.rate = 44100;
format.byte_format = AO_FMT_LITTLE;

device = ao_open_live (driver, format);
% device = ao_open_file (driver, "sinus.wav", 1, format);

define func_1 (wt)
{   
   return sin (wt);
}

define func_2 (wt)
{
   return sin (wt) + .2 * sin (2 * wt) + .05 * sin (4 * wt);
}

freq = integer (__argv [1]);
w = 2 * PI * freq;
buffer = ao_fill_buffer (format, func_1 ([0:w:#format.rate]), func_2 ([0:w:#format.rate]));

forever
  ao_play (device, buffer);

ao_close (device);

ao_shutdown ();
